﻿//engine: JScript
//uname: choiseXDTOType
//dname: Выбрать тип XDTO
//addin: stdlib
//addin: hotkeys hk
//addin: stdcommands
//addin: vbs

// (c) Сосна Евгений
// (c) Александр Орефков <orefkov@gmail.com>
// Скрипт позволяет быстрее выбрать нужный тип XDTO

/// <reference path="./snegopat.d.ts" />
/// <reference path="./v8.d.ts" />

//import * as stdlib from "./std/std";
//import * as stdcommands from "./std/commands";
//import * as hk from "./std/hotkeys";

stdlib.require("SelectValueDialog.js", SelfScript);
stdlib.require('SettingsManagement.js', SelfScript);
global.connectGlobals(SelfScript);

////////////////////////////////////////////////////////////////////////////////////////
////{ Макросы
////

SelfScript.self['macrosНастройка'] = function() {
    var sm = GetXDTOTypeFilter();
    sm.changeSettings();
    return true;
}

/* Возвращает название макроса по умолчанию - вызывается, когда пользователь 
дважды щелкает мышью по названию скрипта в окне Снегопата. */
function getDefaultMacros() {
    return 'Настройка';
}

////} Макросы

XDTOTypeFilter = stdlib.Class.extend({
    settingsRootPath : 'XDTOTypeFilter',
    defaultSettings : {
            LastChoices: undefined,
            MaxLastChoices: 5
    },

    construct : function () {    
        this.settings = SettingsManagement.CreateManager(this.settingsRootPath, this.defaultSettings);
        this.loadSettings();
        XDTOTypeFilter._instance = this;
    },

    loadSettings:function(){
        this.settings.LoadSettings();
        if(!this.settings.current.LastChoices)
            this.settings.current.LastChoices = v8New("СписокЗначений")
        events.connect(windows, "onDoModal", this)
    },

    changeSettings : function(){
        var s = this.settings.current
        vbs.result = s.MaxLastChoices
        if(vbs.DoEval('InputNumber(result, "Максимальный размер быстрого списка", 1, 0)'))
        {
            s.MaxLastChoices = vbs.result
            var cnt = s.LastChoices.Count()
            while(cnt > s.MaxLastChoices)
                s.LastChoices.Delete(--cnt)
            this.settings.SaveSettings()
        }
    },

    onDoModal:function(dlgInfo){
		try{ 
            var form = dlgInfo.form
			
			reCaptionXDTOTypeChoise = /Выбор\sпакетов\sXDTO/ig
            if (reCaptionXDTOTypeChoise.test(dlgInfo.Caption)) {
						
					var treeXDTOTypes   = form.getControl('eTypesGrid')
            			
			} else 
				throw "Не то окно";
			
        }catch(e)   { return }
        // Если это не диалог выбора типов XDTO, то сюда уже не попадем
        if(dlgInfo.stage == afterInitial)
        {
            if(this.DisableSelection)
            {
                // Это мы открыли окно диалога для отключения отбора
                // Имитируем нажатие кнопки "Отключить"
                form.sendEvent(form.getControl('eClear').id, 0)
                delete this.DisableSelection
                return
            }
            // Вытащим список типов XDTO
            var XDTOTypeList = this.fillXDTOTypesList(treeXDTOTypes)
            // Запросим ввод нашим списком
			
            var result = this.filterDialog(XDTOTypeList)
            if(!result)    // Нажали отмену
			{        
				dlgInfo.cancel = true;
                dlgInfo.result = 0;
                return
            }
            
			// Если просто нажали Ок, то результат будет строка грида
            // иначе результат будет объект с полями mode и val
			
		   // почему то перестало работать !result.mode - падает с ошибкой "объект не поддерживает этот метод или свойство".
		   // пришлось завернуть в попытку
		   try{
				if (!result.mode)
					result = {mode:0, row: result}
		   } catch (e) {result = {mode:0, row: result} }
		   
            if(result.mode != 5)    // Не "Открыть стандартный"
            {
                if(result.mode == 4)    // Отключить
                {
                    form.sendEvent(form.getControl('eClear').id, 0)
                    return
                }
                
                var grid = treeXDTOTypes.extInterface
               
				
                // Активируем строку
                grid.currentRow = result.row
               
				form.sendEvent(treeXDTOTypes.id, 17, 1)
				
                this.saveChoice(result.row)
                // Нажмем Ok
                form.sendEvent(form.getControl('ButtOK').id, 0)
                return
            }
            // Сюда попадаем, если выбрали "Открыть стандартный"
            // Запомним контролы и список для работы макросов
			this.data = {XDTOTypeList: XDTOTypeList, form: form, treeXDTOTypes: treeXDTOTypes}
            //this.hotKeys  = [
            //    hotkeys.addTemp(hk.codeFromString('Ctrl+F'), SelfScript.uniqueName, "_FindSubSystem"),
            //    hotkeys.addTemp(hk.codeFromString('Ctrl+Q'), SelfScript.uniqueName, "_ToggleChilds"),
            //    hotkeys.addTemp(hk.codeFromString('Ctrl+W'), SelfScript.uniqueName, "_ToggleParents")
            //]
            //checkChilds.props.setValue("Заголовок", stdlib.LocalWString("Включать объекты подчиненных подсистем (Ctrl + Q)"))
            //checkChilds.props.setValue("Подсказка", stdlib.LocalWString("Ctrl + Q"))
            //checkChilds.props.setValue("Положение заголовка", 1)
            //checkParents.props.setValue("Заголовок", stdlib.LocalWString("Включать объекты родительских подсистем (Ctrl + W)"))
            //checkParents.props.setValue("Подсказка", stdlib.LocalWString("Ctrl + W"))
            //checkParents.props.setValue("Положение заголовка", 1)
            //treeSubSystem.props.setValue("Подсказка", stdlib.LocalWString("Для поиска подсистемы нажмите Ctrl + F"))
        } else if(dlgInfo.stage == afterDoModal) {
            //// dem Пока никаких хоткеев
			//for(var k in this.hotKeys)
            //    hotkeys.removeTemp(this.hotKeys[k])
            //delete this.hotKeys
            //delete this.data
        }
    },
    // Функция при открытии диалога выбора типов XDTO заполняет наш список значений,
    // вытаскивая их состав из грида на форме
    fillXDTOTypesList: function(treeXDTOTypes) {
        // Заполним список типов XDTO
        var valuelist = v8New("СписокЗначений");
        var lastChoices = this.settings.current.LastChoices
        var hotPos = [];
        (function forAllRows(parent, indent, fullPath)
        {
            for(var row = parent.firstChild; row; row = row.next)
            {
				var name = row.getCellValue(0);
                valuelist.Add(row, indent + name);
                var fullName = fullPath + (fullPath.length ? "." : "") + name
                var found = lastChoices.FindByValue(fullName)
                if(found)
                    hotPos.push({idx: lastChoices.IndexOf(found), name: fullName, row: row})
                forAllRows(row, indent + '    ', fullName)
            }
        })(treeXDTOTypes.extInterface.dataSource.root, '', '')
        if(hotPos.length)
        {
            hotPos.sort(function(a, b){return a.idx - b.idx})
            for(var k in hotPos)
                valuelist.Insert(k, hotPos[k].row, hotPos[k].name);
        }
        return valuelist
    },
    filterDialog: function(XDTOTypeList){
        function makeButton(id, text, tooltip, hotkey, modif, mode) {
            return {
                id:id,
                handler: function(dlg, val, btn){if(val || btn.Name.charAt(0)=='e') dlg.form.Закрыть({mode: mode, row:val})},
                params: {Text: text, ToolTip:tooltip, Description: tooltip, Shortcut: stdlib.v8hotkey(hotkey, modif)}
            }
        }
        var dlg = new SelectValueDialog("Какой тип XDTO желаете выбрать?", XDTOTypeList);
		dlg.AddCmdButton([
            makeButton('eStd', "Открыть стандартный", "Открыть стандартный диалог выбора типа XDTO", 0x25, 8, 5),
            {id:'|'}
            ])
		
		return dlg.selectValue() ? dlg.selectedValue : null;
    },
    findSubSystem: function () {
        if(!this.data)
            return
        var dlg = new SelectValueDialog("Какую подсистему желаете отобрать?", this.data.subSystemList);
        if(dlg.selectValue())
        {
            var row = dlg.selectedValue
            var grid = this.data.treeSubSystem.extInterface

            // Активируем строку
            grid.currentRow = row
            // Ставим пометку на выбранной подсистеме
            grid.checkCell(row, 0, 1)

			this.data.form.sendEvent(this.data.treeSubSystem.id, 17, 1)
			
            this.saveChoice(row)
        }
    },
    toggleCheckParents: function()
    {
        if(this.data)
            this.data.checkParents.value = !this.data.checkParents.value
    },
    toggleCheckChilds: function()
    {
        if(this.data)
            this.data.checkChilds.value = !this.data.checkChilds.value
    },
    // Сохранение выбранного типа XDTO в списке недавно выбранных
    saveChoice: function(row)
    {
        // Для начала сформируем полное имя типа XDTO
        var fullName = ""
        while(row)
        {
            fullName = row.getCellValue(0) + (fullName.length ? "." : "") + fullName
            row = row.parent
        }
        var vl = this.settings.current.LastChoices
        // Теперь надо вставить полученную строку в начало списка.
        // Если она уже есть, сдвинем ее
        var found = vl.FindByValue(fullName)
        if(found)
        {
            var idx = vl.IndexOf(found)
            if(0 != idx) {
                vl.Move(idx, -idx)
                this.settings.SaveSettings()
            }
            return
        }
        vl.Insert(0, fullName)
        if(vl.Count() > this.settings.current.MaxLastChoices)
            vl.Delete(this.settings.current.MaxLastChoices)
        this.settings.SaveSettings()
    }
})

function GetXDTOTypeFilter() {
    if (!XDTOTypeFilter._instance)
        new XDTOTypeFilter();
    
    return XDTOTypeFilter._instance;
}

var cht = GetXDTOTypeFilter();
